<?php

namespace App\Filament\Exports;

use App\Models\StickerStructureDetail;
use Filament\Actions\Exports\ExportColumn;
use Filament\Actions\Exports\Exporter;
use Filament\Actions\Exports\Models\Export;

class StickerStructureDetailExporter extends Exporter
{
    protected static ?string $model = StickerStructureDetail::class;

    public static function getColumns(): array
    {
        static $rowNumber = 0;
        return [
            ExportColumn::make('no')
                ->label('NO')
                ->state(function ($record) use (&$rowNumber) {
                    // Increment and return the row number
                    return ++$rowNumber;
                }),
            ExportColumn::make('sticker_id')
            ->label('STICKER ID'),
            ExportColumn::make('sticker_width')
            ->label('STICKER WIDTH'),
            ExportColumn::make('sticker_height')
            ->label('STICKER HEIGHT'),
            ExportColumn::make('sticker_lmargin')
            ->label('STICKER LEFT MARGIN'),
            ExportColumn::make('sticker_rmargin')
            ->label('STICKER RIGHT MARGIN'),
            ExportColumn::make('sticker_tmargin')
            ->label('STICKER TOP MARGIN'),
            ExportColumn::make('sticker_bmargin')
            ->label('STICKER BOTTOM MARGIN'),
            ExportColumn::make('created_at')
            ->label('CREATED AT'),
            ExportColumn::make('updated_at')
            ->label('UPDATED AT'),
            ExportColumn::make('created_by')
            ->label('CREATED BY'),
            ExportColumn::make('updated_by')
            ->label('UPDATED BY'),
            ExportColumn::make('deleted_at')
            ->label('DELETED AT')
            ->enabledByDefault(false),
        ];
    }

    public static function getCompletedNotificationBody(Export $export): string
    {
        $body = 'Your sticker structure detail export has completed and ' . number_format($export->successful_rows) . ' ' . str('row')->plural($export->successful_rows) . ' exported.';

        if ($failedRowsCount = $export->getFailedRowsCount()) {
            $body .= ' ' . number_format($failedRowsCount) . ' ' . str('row')->plural($failedRowsCount) . ' failed to export.';
        }

        return $body;
    }
}
